var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import { split, replace, fsFormat } from "fable-core/String";
import { setType } from "fable-core/Symbol";
import _Symbol from "fable-core/Symbol";
import { toString, Array as _Array, compareRecords, equalsRecords, compareUnions, equalsUnions } from "fable-core/Util";
import { CamlQuery, FileCreationInformation, ContentTypeCreationInformation, ListCreationInformation } from "SP";
import { PromiseImpl } from "../node_modules/fable-powerpack/Promise";
import { singleton, enumerateWhile, delay } from "fable-core/Seq";
export function onQueryFailed(sender, args) {
    var message = fsFormat("Request failed. %s \n%s\n ")(function (x) {
        return x;
    })(args.get_message())(args.get_stackTrace());
    log4javascript.getLogger().debug(message);
    log4javascript.getLogger().debug(args);
    log4javascript.getLogger().debug("------------------------------------------------------------------------");
    throw new Error(message);
}
export function nothingOnQueryFailed(sender, args) {}
export var FieldType = function () {
    function FieldType(caseName, fields) {
        _classCallCheck(this, FieldType);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(FieldType, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "SharePoint.Support.FieldType",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    AllDayEvent: [],
                    Attachments: [],
                    Boolean: [],
                    Calculate: [],
                    Choice: [],
                    Computed: [],
                    ContenttypeID: [],
                    Counter: [],
                    CrossProjectLink: [],
                    Currency: [],
                    DateTime: [],
                    Error: [],
                    File: [],
                    Geolocation: [],
                    GridChoice: [],
                    Guid: [],
                    Integer: [],
                    Invalid: [],
                    MaxItems: [],
                    ModStat: [],
                    MultiChoice: [],
                    Note: [],
                    Number: [],
                    OutcomeChoice: [],
                    PageSeparator: [],
                    Recurrence: [],
                    Text: [],
                    ThreadIndex: [],
                    Threading: [],
                    Url: [],
                    User: [],
                    WorkflowEventType: [],
                    WorkflowStatus: []
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }, {
        key: "toString",
        get: function () {
            if (this.Case === "Attachments") {
                return "Attachments";
            } else if (this.Case === "Boolean") {
                return "Boolean";
            } else if (this.Case === "Calculate") {
                return "Calculate";
            } else if (this.Case === "Choice") {
                return "Choice";
            } else if (this.Case === "Computed") {
                return "Computed";
            } else if (this.Case === "ContenttypeID") {
                return "ContenttypeID";
            } else if (this.Case === "Counter") {
                return "Counter";
            } else if (this.Case === "CrossProjectLink") {
                return "CrossProjectLink";
            } else if (this.Case === "Currency") {
                return "Currency";
            } else if (this.Case === "DateTime") {
                return "DateTime";
            } else if (this.Case === "Error") {
                return "Error";
            } else if (this.Case === "File") {
                return "File";
            } else if (this.Case === "Geolocation") {
                return "Geolocation";
            } else if (this.Case === "GridChoice") {
                return "GridChoice";
            } else if (this.Case === "Guid") {
                return "Guid";
            } else if (this.Case === "Integer") {
                return "Integer";
            } else if (this.Case === "Invalid") {
                return "Invalid";
            } else if (this.Case === "MaxItems") {
                return "MaxItems";
            } else if (this.Case === "ModStat") {
                return "ModStat";
            } else if (this.Case === "MultiChoice") {
                return "MultiChoice";
            } else if (this.Case === "Note") {
                return "Note";
            } else if (this.Case === "Number") {
                return "Number";
            } else if (this.Case === "OutcomeChoice") {
                return "OutcomeChoice";
            } else if (this.Case === "PageSeparator") {
                return "PageSeparator";
            } else if (this.Case === "Recurrence") {
                return "Recurrence";
            } else if (this.Case === "Text") {
                return "Text";
            } else if (this.Case === "ThreadIndex") {
                return "ThreadIndex";
            } else if (this.Case === "Threading") {
                return "Threading";
            } else if (this.Case === "Url") {
                return "Url";
            } else if (this.Case === "User") {
                return "User";
            } else if (this.Case === "WorkflowEventType") {
                return "WorkflowEventType";
            } else if (this.Case === "WorkflowStatus") {
                return "WorkflowStatus";
            } else {
                return "AllDayEvent";
            }
        }
    }]);

    return FieldType;
}();
setType("SharePoint.Support.FieldType", FieldType);
export var StandardFieldDefinition = function () {
    function StandardFieldDefinition(name, displayName, required, fieldType, iD) {
        _classCallCheck(this, StandardFieldDefinition);

        this.Name = name;
        this.DisplayName = displayName;
        this.Required = required;
        this.FieldType = fieldType;
        this.ID = iD;
    }

    _createClass(StandardFieldDefinition, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "SharePoint.Support.StandardFieldDefinition",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    Name: "string",
                    DisplayName: "string",
                    Required: "boolean",
                    FieldType: FieldType,
                    ID: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return StandardFieldDefinition;
}();
setType("SharePoint.Support.StandardFieldDefinition", StandardFieldDefinition);
export var LookupFieldDefinition = function () {
    function LookupFieldDefinition(name, displayName, required, lookupListName, lookupFieldDisplayName, iD) {
        _classCallCheck(this, LookupFieldDefinition);

        this.Name = name;
        this.DisplayName = displayName;
        this.Required = required;
        this.LookupListName = lookupListName;
        this.LookupFieldDisplayName = lookupFieldDisplayName;
        this.ID = iD;
    }

    _createClass(LookupFieldDefinition, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "SharePoint.Support.LookupFieldDefinition",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    Name: "string",
                    DisplayName: "string",
                    Required: "boolean",
                    LookupListName: "string",
                    LookupFieldDisplayName: "string",
                    ID: "string"
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return LookupFieldDefinition;
}();
setType("SharePoint.Support.LookupFieldDefinition", LookupFieldDefinition);
export var FieldDefinition = function () {
    function FieldDefinition(caseName, fields) {
        _classCallCheck(this, FieldDefinition);

        this.Case = caseName;
        this.Fields = fields;
    }

    _createClass(FieldDefinition, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "SharePoint.Support.FieldDefinition",
                interfaces: ["FSharpUnion", "System.IEquatable", "System.IComparable"],
                cases: {
                    LookupFieldDefinition: [LookupFieldDefinition],
                    StandardFieldDefinition: [StandardFieldDefinition]
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsUnions(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareUnions(this, other);
        }
    }]);

    return FieldDefinition;
}();
setType("SharePoint.Support.FieldDefinition", FieldDefinition);
export var ListDefinition = function () {
    function ListDefinition(displayName, url, fields) {
        _classCallCheck(this, ListDefinition);

        this.DisplayName = displayName;
        this.Url = url;
        this.Fields = fields;
    }

    _createClass(ListDefinition, [{
        key: _Symbol.reflection,
        value: function () {
            return {
                type: "SharePoint.Support.ListDefinition",
                interfaces: ["FSharpRecord", "System.IEquatable", "System.IComparable"],
                properties: {
                    DisplayName: "string",
                    Url: "string",
                    Fields: _Array(FieldDefinition)
                }
            };
        }
    }, {
        key: "Equals",
        value: function (other) {
            return equalsRecords(this, other);
        }
    }, {
        key: "CompareTo",
        value: function (other) {
            return compareRecords(this, other);
        }
    }]);

    return ListDefinition;
}();
setType("SharePoint.Support.ListDefinition", ListDefinition);
export function executeQuery(clientContext) {
    var deferred = jQuery.Deferred();
    clientContext.executeQueryAsync(function (_arg1, _arguments) {
        deferred.resolve(_arguments);
    }, function (_arg2, _arguments_1) {
        deferred.reject(_arguments_1);
    });
    return deferred.promise();
}
export function createCustomList(title, url, clientContext) {
    (function (builder_) {
        return builder_.Delay(function () {
            var web = clientContext.get_web();
            var listCollection = web.get_lists();
            clientContext.load(listCollection);
            var list1 = listCollection.getByTitle(title);
            clientContext.load(list1);

            var execQuery = function execQuery() {
                return executeQuery(clientContext);
            };

            var doCreateList = function doCreateList() {
                return function (builder__1) {
                    return builder__1.Delay(function () {
                        var listCreationInfo = new ListCreationInformation();
                        listCreationInfo.set_title(title);
                        listCreationInfo.set_url("Lists/" + url);
                        listCreationInfo.set_templateType(100);
                        var list1_1 = web.get_lists().add(listCreationInfo);
                        clientContext.load(list1_1);
                        return execQuery(null).then(function () {
                            return Promise.resolve(null);
                        });
                    });
                }(PromiseImpl.promise);
            };

            return execQuery(null).then(function () {
                return doCreateList(null).then(function () {
                    return Promise.resolve(null);
                });
            });
        });
    })(PromiseImpl.promise).then(function () {});
}

function createCustomListInt(title, url, createContentType, continue1, listCollection, web, clientContext) {
    var list1 = listCollection.getByTitle(title);
    clientContext.load(list1);
    var itemContentType = clientContext.get_web().get_contentTypes().getById("0x01");
    clientContext.load(itemContentType);

    var createContentType_1 = function createContentType_1(list) {
        return function (andThen) {
            if (createContentType) {
                var contentTypeCreationInformation = new ContentTypeCreationInformation();
                contentTypeCreationInformation.set_name(title);
                contentTypeCreationInformation.set_parentContentType(itemContentType);
                var newContentType = list.get_contentTypes().add(contentTypeCreationInformation);
                clientContext.load(newContentType);
                clientContext.executeQueryAsync(function (_arg2, _arg1) {
                    andThen(newContentType);
                }, function (delegateArg0, delegateArg1) {
                    onQueryFailed(delegateArg0, delegateArg1);
                });
            }

            andThen(null);
        };
    };

    clientContext.executeQueryAsync(function (_arg4, _arg3) {
        continue1(list1)(null)(clientContext);
    }, function (_arg8, _arg7) {
        var listCreationInfo = new ListCreationInformation();
        listCreationInfo.set_title(title);
        listCreationInfo.set_url("Lists/" + url);
        listCreationInfo.set_templateType(100);
        var list1_1 = web.get_lists().add(listCreationInfo);
        clientContext.load(list1_1);
        clientContext.executeQueryAsync(function (_arg6, _arg5) {
            var moveOn = function moveOn(contentType) {
                continue1(list1_1)(contentType)(clientContext);
            };

            createContentType_1(list1_1)(moveOn);
        }, function (delegateArg0_1, delegateArg1_1) {
            onQueryFailed(delegateArg0_1, delegateArg1_1);
        });
    });
}

export function getListIdAsync(title, listCollection, clientContext) {
    return function (builder_) {
        return builder_.Delay(function () {
            var list1 = listCollection.getByTitle(title);
            clientContext.load(list1, "Id");

            var execQuery = function execQuery() {
                return executeQuery(clientContext);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(list1);
            });
        });
    }(PromiseImpl.promise);
}
export function fixColumnName(name) {
    return replace(name, " ", "_x0020_");
}
export function uploadMasterPage(content, clientContext) {
    var web = clientContext.get_web();
    var folder = web.getFolderByServerRelativeUrl("");
    var files = folder.get_files();
    var file = new FileCreationInformation();
    file.set_content(content);
    var file_1 = files.add(file);
    file_1.checkOut();
}
export function convert(source) {
    var enumerator = source.getEnumerator();
    var mResult = Array.from(delay(function () {
        return enumerateWhile(function () {
            return enumerator.moveNext();
        }, delay(function () {
            var result = enumerator.get_current();
            return singleton(result);
        }));
    }));
    return mResult;
}
export function getSubscriptionsByList(context, web, listId) {
    (function (builder_) {
        return builder_.Delay(function () {
            var sMgr = new SP.WorkflowServices.WorkflowServicesManager(context, web);
            var sservice = sMgr.getWorkflowSubscriptionService();
            var ssubs = sservice.enumerateSubscriptionsByList(listId);
            context.load(ssubs);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            return execQuery(null).then(function () {
                var e = ssubs.getEnumerator();
                return builder_.While(function () {
                    return e.moveNext();
                }, builder_.Delay(function () {
                    var c = e.get_current();
                    log4javascript.getLogger().debug("Name :" + toString(c.get_name()) + " sID: " + toString(c.get_id()));
                    return Promise.resolve();
                }));
            });
        });
    })(PromiseImpl.promise).then(function () {});
}
export function getSubscriptionById(context, web, subscriptionId) {
    var wfServiceManager = SP.WorkflowServices.WorkflowServicesManager.newObject(context, web);
    var subscription = wfServiceManager.getWorkflowSubscriptionService().getSubscription(subscriptionId);
    context.load(subscription);
    return subscription;
}
export function startWorkFlow(context, web, subscription, itemId) {
    (function (builder_) {
        return builder_.Delay(function () {
            var wfServiceManager = SP.WorkflowServices.WorkflowServicesManager.newObject(context, web);
            var inputParameters = new Map();
            wfServiceManager.getWorkflowInstanceService().startWorkflowOnListItem(subscription, itemId, inputParameters);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(null);
            });
        });
    })(PromiseImpl.promise).then(function () {});
}
export function startSiteWorkFlow(context, web, subscription, inputParameters) {
    (function (builder_) {
        return builder_.Delay(function () {
            var wfServiceManager = SP.WorkflowServices.WorkflowServicesManager.newObject(context, web);
            wfServiceManager.getWorkflowInstanceService().startWorkflow(subscription, inputParameters);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(null);
            });
        });
    })(PromiseImpl.promise).then(function () {});
}
export function disableDragAndDrop() {
    window.g_uploadType = DragDropMode.NOTSUPPORTED;
    SPDragDropManager.DragDropMode = DragDropMode.NOTSUPPORTED;
}
export function nearestTd(el) {
    return el.parents("td");
}
export var idAttachmentsRow = "idAttachmentsRow";
export function isCurrentUserMemberOfGroup(clientContext, groupName) {
    return function (builder_) {
        return builder_.Delay(function () {
            var web = clientContext.get_web();
            var currentUser = web.get_currentUser();
            clientContext.load(currentUser);
            var userGroups = currentUser.get_groups();
            clientContext.load(userGroups);

            var execQuery = function execQuery() {
                return executeQuery(clientContext);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(convert(userGroups).some(function (p) {
                    return p.get_title() === groupName;
                }));
            });
        });
    }(PromiseImpl.promise);
}
export function getCurrentUserAsync(clientContext) {
    return function (builder_) {
        return builder_.Delay(function () {
            var web = clientContext.get_web();
            var currentUser = web.get_currentUser();
            clientContext.load(currentUser);
            var userGroups = currentUser.get_groups();
            clientContext.load(userGroups);

            var execQuery = function execQuery() {
                return executeQuery(clientContext);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(currentUser);
            });
        });
    }(PromiseImpl.promise);
}
export function getUserByIdAsync(context, web, id) {
    return function (builder_) {
        return builder_.Delay(function () {
            var user = web.get_siteUsers().getById(id);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            context.load(user);
            return execQuery(null).then(function () {
                return Promise.resolve(user);
            });
        });
    }(PromiseImpl.promise);
}
export function approveOrRejectTask(clientContext, taskId, listName, approve) {
    return function (builder_) {
        return builder_.Delay(function () {
            var list = clientContext.get_web().get_lists().getByTitle(listName);
            var task = list.getItemById(taskId);
            var status = approve ? "Approved" : "Rejected";
            task.set_item("Completed", true);
            task.set_item("PercentComplete", 1);
            task.set_item("Status", status);
            task.set_item("WorkflowOutcome", status);
            task.update();

            var execQuery = function execQuery() {
                return executeQuery(clientContext);
            };

            return execQuery(null).then(function () {
                return Promise.resolve(null);
            });
        });
    }(PromiseImpl.promise);
}
export function createFolders(context, library, folderNames) {
    return function (builder_) {
        return builder_.Delay(function () {
            log4javascript.getLogger().debug("createFolder() started");

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            folderNames.forEach(function (folderName) {
                try {
                    var createInfo = new SP.ListItemCreationInformation();
                    createInfo.set_underlyingObjectType(SP.FileSystemObjectType.folder);
                    createInfo.set_leafName(folderName);
                    var item = library.addItem(createInfo);
                    item.update();
                    context.load(item);
                } catch (ex) {
                    log4javascript.getLogger().debug(fsFormat("Creation of subfolder %s failed with %A")(function (x) {
                        return x;
                    })(folderName)(ex));
                }
            });
            return execQuery(null).then(function () {
                return Promise.resolve(null);
            });
        });
    }(PromiseImpl.promise);
}
export function updateColumnValue(context, web, listName, itemId, columnName, columnValue) {
    return function (builder_) {
        return builder_.Delay(function () {
            var item = web.get_lists().getByTitle(listName).getItemById(itemId);
            item.set_item(columnName, columnValue);
            item.update();
            return Promise.resolve();
        });
    }(PromiseImpl.promise);
}
export function getAllListItems(context, web, listName, includePart) {
    return function (builder_) {
        return builder_.Delay(function () {
            var list = web.get_lists().getByTitle(listName);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            return function () {
                var matchValue = includePart === "";

                if (matchValue) {
                    context.load(list);
                    return Promise.resolve();
                } else {
                    context.load(list, includePart);
                    return Promise.resolve();
                }
            }().then(function () {
                return builder_.Delay(function () {
                    return execQuery(null).then(function () {
                        var query = CamlQuery.createAllItemsQuery();
                        var items = list.getItems(query);
                        context.load(items);
                        return execQuery(null).then(function () {
                            log4javascript.getLogger().debug(fsFormat("listItems.get_count %A")(function (x) {
                                return x;
                            })(items.get_count()));
                            return Promise.resolve(items);
                        });
                    });
                });
            });
        });
    }(PromiseImpl.promise);
}
export function getSiteNameFromUrl() {
    var urlParts = split(location.href, "/");
    var committees = location.href.indexOf("/eon/") >= 0 ? "eon" : "committees";
    var index = urlParts.findIndex(function (f) {
        return f === committees;
    });
    return urlParts[index + 2];
}
export function getNormalizedSiteName() {
    var urlSpace = "%20";
    var originalBoardName = getSiteNameFromUrl();
    var boardName = replace(originalBoardName, urlSpace, " ");
    return boardName;
}
export function getListNameFromUrl() {
    var urlParts = split(location.href, "/");
    var indexOfAspx = urlParts.findIndex(function (x) {
        return x.indexOf(".aspx") >= 0;
    });
    return urlParts[indexOfAspx - 1];
}
export function getLibraryNameFromUrl() {
    var urlParts = split(location.href, "/");
    var indexOfAspx = urlParts.findIndex(function (x) {
        return x.indexOf(".aspx") >= 0;
    });
    return urlParts[indexOfAspx - 2];
}
export function getVal(columnName, item) {
    return item.get_item(fixColumnName(columnName));
}
export function toStringSafe(v) {
    if (v == null) {
        return "";
    } else {
        var vs = toString(v);

        if (vs === "null") {
            return "";
        } else {
            return vs;
        }
    }
}
export function getValS(columnName, item) {
    return jQuery('<div>').html(toStringSafe(getVal(columnName, item))).text();
}
export function getListItemsByCaml(web, context, listName, fieldNames, camlQuery, mapper) {
    console.log("getListItemsByCaml started for " + listName);
    return function (builder_) {
        return builder_.Delay(function () {
            var itemList = web.get_lists().getByTitle(listName);
            context.load(itemList);

            var execQuery = function execQuery() {
                return executeQuery(context);
            };

            return execQuery(null).then(function () {
                var caml = new CamlQuery();
                caml.set_viewXml(camlQuery);
                var listItems = itemList.getItems(caml);
                context.load(listItems, fsFormat("Include(Id,%s)")(function (x) {
                    return x;
                })(fieldNames));
                return execQuery(null).then(function () {
                    var res = function (array) {
                        return array.map(mapper);
                    }(convert(listItems));

                    console.log("getListItemsByCaml succeeded for " + listName);
                    return Promise.resolve(res);
                });
            });
        });
    }(PromiseImpl.promise);
}
//# sourceMappingURL=SharePoint.Support.js.map