(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports", "SP"], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require("SP"));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.SP);
        global.FableImportSharePointSP = mod.exports;
    }
})(this, function (exports, _SP) {
    "use strict";

    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.InformationPolicy = exports.Discovery = exports.CompliancePolicy = exports.Publishing = exports.Workflow = exports.WebParts = exports.DateTimeUtil = exports.Utilities = exports.UserProfiles = exports.UI = exports.Video = exports.DocumentSet = exports.Taxonomy = exports.Social = exports.Sharing = exports.BusinessData = exports.SiteHealth = exports.Analytics = exports.Application = exports.WebTemplateCollection = exports.WebTemplate = exports.WebResponseInfo = exports.WebRequestInfo = exports.WebProxy = exports.WebInformation = exports.WebCreationInformation = exports.WebCollection = exports.Web = exports.ViewFieldCollection = exports.ViewCreationInformation = exports.ViewCollection = exports.View = exports.UserIdInfo = exports.UserCustomActionCollection = exports.UserCustomAction = exports.UserCreationInformation = exports.UserCollection = exports.User = exports.UsageInfo = exports.UpgradeInfo = undefined;
    exports.TimeZoneInformation = exports.TimeZoneCollection = exports.TimeZone = exports.ThemeInfo = exports.SubwebQuery = exports.SiteUrl = exports.Site = exports.ServerSettings = exports.RoleDefinitionCreationInformation = exports.RoleDefinitionCollection = exports.RoleDefinitionBindingCollection = exports.RoleDefinition = exports.RoleAssignmentCollection = exports.RoleAssignment = exports.RequestVariable = exports.RelatedItemManager = exports.RelatedItem = exports.RelatedFieldExtendedDataCollection = exports.RelatedFieldExtendedData = exports.RelatedFieldCollection = exports.RelatedField = exports.RegionalSettings = exports.RecycleBinItemCollection = exports.RecycleBinItem = exports.PushNotificationSubscriberCollection = exports.PushNotificationSubscriber = exports.PropertyValues = exports.ObjectSharingInformationUser = exports.ObjectSharingInformation = exports.NavigationNodeCreationInformation = exports.NavigationNodeCollection = exports.NavigationNode = exports.Navigation = exports.ListTemplateCollection = exports.ListTemplate = exports.ListItemFormUpdateValue = exports.ListItemEntityCollection = exports.ListItemCreationInformation = exports.ListItemCollectionPosition = exports.ListItemCollection = exports.ListItem = exports.ListDataValidationFailure = exports.ListDataValidationExceptionValue = exports.ListDataSource = exports.ListCreationInformation = exports.ListCollection = exports.List = exports.SecurableObject = exports.Language = exports.InformationRightsManagementSettings = exports.GroupCreationInformation = exports.GroupCollection = exports.Group = exports.Principal = exports.FormCollection = exports.Form = exports.FolderCollection = exports.Folder = exports.FileVersionCollection = exports.FileVersion = exports.FileSaveBinaryInformation = exports.FileCreationInformation = exports.FileCollection = exports.File = exports.FieldUserValue = exports.FieldUser = exports.FieldUrlValue = exports.FieldUrl = exports.FieldText = exports.FieldStringValues = exports.FieldRatingScaleQuestionAnswer = exports.FieldRatingScale = exports.FieldMultiLineText = exports.FieldLookupValue = exports.FieldLookup = exports.FieldLinkCreationInformation = exports.FieldLinkCollection = exports.FieldLink = exports.FieldGuid = exports.FieldGeolocationValue = exports.FieldGeolocation = exports.FieldDateTime = exports.FieldCurrency = exports.FieldNumber = exports.FieldComputed = exports.FieldCollection = exports.FieldChoice = exports.FieldMultiChoice = exports.FieldCalculatedErrorValue = exports.FieldCalculated = exports.Field = exports.FeatureCollection = exports.Feature = exports.EventReceiverDefinitionCreationInformation = exports.EventReceiverDefinitionCollection = exports.EventReceiverDefinition = exports.ContentTypeId = exports.ContentTypeCreationInformation = exports.ContentTypeCollection = exports.ContentType = undefined;
    exports.CompatibilityRange = exports.ChangeWeb = exports.ChangeView = exports.ChangeUser = exports.ChangeToken = exports.ChangeSite = exports.ChangeQuery = exports.ChangeLogItemQuery = exports.ChangeList = exports.ChangeItem = exports.ChangeGroup = exports.ChangeFolder = exports.ChangeFile = exports.ChangeField = exports.ChangeContentType = exports.ChangeCollection = exports.ChangeAlert = exports.Change = exports.CamlQuery = exports.BasePermissions = exports.AttachmentCreationInformation = exports.AttachmentCollection = exports.Attachment = exports.AppLicenseCollection = exports.AppLicense = exports.AppInstanceErrorDetails = exports.AppInstance = exports.AppContextSite = exports.AppCatalog = exports.App = exports.AlternateUrl = exports.AccessRequests = exports.ULS = exports.ClientContext = exports.ClientRuntimeContext = exports.OfficeVersion = exports.ParseJSONUtil = exports.RuntimeRes = exports.ResourceStrings = exports.SerializationContext = exports.ObjectPathConstructor = exports.ObjectPathStaticMethod = exports.ObjectPathMethod = exports.ObjectPathStaticProperty = exports.ObjectPathProperty = exports.ObjectPath = exports.ObjectIdentityQuery = exports.ExceptionHandlingScope = exports.ClientValueObjectCollection = exports.ClientValueObject = exports.SimpleDataTable = exports.ClientRequestSucceededEventArgs = exports.ClientRequestFailedEventArgs = exports.ClientRequestEventArgs = exports.ClientRequest = exports.WebRequestEventArgs = exports.ClientObjectCollectionPrototype = exports.ClientObjectPrototype = exports.ClientObjectList = exports.ClientObjectCollection = exports.ClientObjectData = exports.ClientObject = exports.ClientActionInvokeStaticMethod = exports.ClientActionInvokeMethod = exports.ClientActionSetStaticProperty = exports.ClientActionSetProperty = exports.ClientAction = exports.ClientErrorCodes = exports.ClientSchemaVersions = exports.ClientConstants = exports.XmlWriter = exports.ResResources = exports.DataConvert = exports.ClientXDocument = exports.ClientXElement = exports.XElement = exports.ClientUtility = exports.ClientDictionaryResultHandler = exports.JsonObjectResult = exports.GuidResult = exports.DateTimeResult = exports.StringResult = exports.DoubleResult = exports.IntResult = exports.CharResult = exports.BooleanResult = exports.ClientResult = exports.ClientObjectPropertyConditionalScope = exports.ConditionalScopeBase = exports.Base64EncodedByteArray = exports.BaseCollection = exports.Guid = exports.ScriptUtility = exports.RequestExecutor = exports.ListOperation = exports.ContextPermissions = exports.PageContextInfo = exports.ScriptHelpers = exports.HtmlBuilder = exports.SOD = undefined;
    var SOD = exports.SOD = _SP.SOD;
    var HtmlBuilder = exports.HtmlBuilder = _SP.HtmlBuilder;
    var ScriptHelpers = exports.ScriptHelpers = _SP.ScriptHelpers;
    var PageContextInfo = exports.PageContextInfo = _SP.PageContextInfo;
    var ContextPermissions = exports.ContextPermissions = _SP.ContextPermissions;

    var ListOperation = exports.ListOperation = function (__exports) {
        var ViewOperation = __exports.ViewOperation = function (__exports) {
            var Globals = __exports.Globals = _SP.ListOperation.ViewOperation;
            return __exports;
        }({});

        var Selection = __exports.Selection = function (__exports) {
            var Globals = __exports.Globals = _SP.ListOperation.Selection;
            return __exports;
        }({});

        var Overrides = __exports.Overrides = function (__exports) {
            var Globals = __exports.Globals = _SP.ListOperation.Overrides;
            return __exports;
        }({});

        return __exports;
    }({});

    var RequestExecutor = exports.RequestExecutor = _SP.RequestExecutor;
    var ScriptUtility = exports.ScriptUtility = _SP.ScriptUtility;
    var Guid = exports.Guid = _SP.Guid;
    var BaseCollection = exports.BaseCollection = _SP.BaseCollection;
    var Base64EncodedByteArray = exports.Base64EncodedByteArray = _SP.Base64EncodedByteArray;
    var ConditionalScopeBase = exports.ConditionalScopeBase = _SP.ConditionalScopeBase;
    var ClientObjectPropertyConditionalScope = exports.ClientObjectPropertyConditionalScope = _SP.ClientObjectPropertyConditionalScope;
    var ClientResult = exports.ClientResult = _SP.ClientResult;
    var BooleanResult = exports.BooleanResult = _SP.BooleanResult;
    var CharResult = exports.CharResult = _SP.CharResult;
    var IntResult = exports.IntResult = _SP.IntResult;
    var DoubleResult = exports.DoubleResult = _SP.DoubleResult;
    var StringResult = exports.StringResult = _SP.StringResult;
    var DateTimeResult = exports.DateTimeResult = _SP.DateTimeResult;
    var GuidResult = exports.GuidResult = _SP.GuidResult;
    var JsonObjectResult = exports.JsonObjectResult = _SP.JsonObjectResult;
    var ClientDictionaryResultHandler = exports.ClientDictionaryResultHandler = _SP.ClientDictionaryResultHandler;
    var ClientUtility = exports.ClientUtility = _SP.ClientUtility;
    var XElement = exports.XElement = _SP.XElement;
    var ClientXElement = exports.ClientXElement = _SP.ClientXElement;
    var ClientXDocument = exports.ClientXDocument = _SP.ClientXDocument;
    var DataConvert = exports.DataConvert = _SP.DataConvert;
    var ResResources = exports.ResResources = _SP.ResResources;
    var XmlWriter = exports.XmlWriter = _SP.XmlWriter;
    var ClientConstants = exports.ClientConstants = _SP.ClientConstants;
    var ClientSchemaVersions = exports.ClientSchemaVersions = _SP.ClientSchemaVersions;
    var ClientErrorCodes = exports.ClientErrorCodes = _SP.ClientErrorCodes;
    var ClientAction = exports.ClientAction = _SP.ClientAction;
    var ClientActionSetProperty = exports.ClientActionSetProperty = _SP.ClientActionSetProperty;
    var ClientActionSetStaticProperty = exports.ClientActionSetStaticProperty = _SP.ClientActionSetStaticProperty;
    var ClientActionInvokeMethod = exports.ClientActionInvokeMethod = _SP.ClientActionInvokeMethod;
    var ClientActionInvokeStaticMethod = exports.ClientActionInvokeStaticMethod = _SP.ClientActionInvokeStaticMethod;
    var ClientObject = exports.ClientObject = _SP.ClientObject;
    var ClientObjectData = exports.ClientObjectData = _SP.ClientObjectData;
    var ClientObjectCollection = exports.ClientObjectCollection = _SP.ClientObjectCollection;
    var ClientObjectList = exports.ClientObjectList = _SP.ClientObjectList;
    var ClientObjectPrototype = exports.ClientObjectPrototype = _SP.ClientObjectPrototype;
    var ClientObjectCollectionPrototype = exports.ClientObjectCollectionPrototype = _SP.ClientObjectCollectionPrototype;
    var WebRequestEventArgs = exports.WebRequestEventArgs = _SP.WebRequestEventArgs;
    var ClientRequest = exports.ClientRequest = _SP.ClientRequest;
    var ClientRequestEventArgs = exports.ClientRequestEventArgs = _SP.ClientRequestEventArgs;
    var ClientRequestFailedEventArgs = exports.ClientRequestFailedEventArgs = _SP.ClientRequestFailedEventArgs;
    var ClientRequestSucceededEventArgs = exports.ClientRequestSucceededEventArgs = _SP.ClientRequestSucceededEventArgs;
    var SimpleDataTable = exports.SimpleDataTable = _SP.SimpleDataTable;
    var ClientValueObject = exports.ClientValueObject = _SP.ClientValueObject;
    var ClientValueObjectCollection = exports.ClientValueObjectCollection = _SP.ClientValueObjectCollection;
    var ExceptionHandlingScope = exports.ExceptionHandlingScope = _SP.ExceptionHandlingScope;
    var ObjectIdentityQuery = exports.ObjectIdentityQuery = _SP.ObjectIdentityQuery;
    var ObjectPath = exports.ObjectPath = _SP.ObjectPath;
    var ObjectPathProperty = exports.ObjectPathProperty = _SP.ObjectPathProperty;
    var ObjectPathStaticProperty = exports.ObjectPathStaticProperty = _SP.ObjectPathStaticProperty;
    var ObjectPathMethod = exports.ObjectPathMethod = _SP.ObjectPathMethod;
    var ObjectPathStaticMethod = exports.ObjectPathStaticMethod = _SP.ObjectPathStaticMethod;
    var ObjectPathConstructor = exports.ObjectPathConstructor = _SP.ObjectPathConstructor;
    var SerializationContext = exports.SerializationContext = _SP.SerializationContext;
    var ResourceStrings = exports.ResourceStrings = _SP.ResourceStrings;
    var RuntimeRes = exports.RuntimeRes = _SP.RuntimeRes;
    var ParseJSONUtil = exports.ParseJSONUtil = _SP.ParseJSONUtil;
    var OfficeVersion = exports.OfficeVersion = _SP.OfficeVersion;
    var ClientRuntimeContext = exports.ClientRuntimeContext = _SP.ClientRuntimeContext;
    var ClientContext = exports.ClientContext = _SP.ClientContext;
    var ULS = exports.ULS = _SP.ULS;
    var AccessRequests = exports.AccessRequests = _SP.AccessRequests;
    var AlternateUrl = exports.AlternateUrl = _SP.AlternateUrl;
    var App = exports.App = _SP.App;
    var AppCatalog = exports.AppCatalog = _SP.AppCatalog;
    var AppContextSite = exports.AppContextSite = _SP.AppContextSite;
    var AppInstance = exports.AppInstance = _SP.AppInstance;
    var AppInstanceErrorDetails = exports.AppInstanceErrorDetails = _SP.AppInstanceErrorDetails;
    var AppLicense = exports.AppLicense = _SP.AppLicense;
    var AppLicenseCollection = exports.AppLicenseCollection = _SP.AppLicenseCollection;
    var Attachment = exports.Attachment = _SP.Attachment;
    var AttachmentCollection = exports.AttachmentCollection = _SP.AttachmentCollection;
    var AttachmentCreationInformation = exports.AttachmentCreationInformation = _SP.AttachmentCreationInformation;
    var BasePermissions = exports.BasePermissions = _SP.BasePermissions;
    var CamlQuery = exports.CamlQuery = _SP.CamlQuery;
    var Change = exports.Change = _SP.Change;
    var ChangeAlert = exports.ChangeAlert = _SP.ChangeAlert;
    var ChangeCollection = exports.ChangeCollection = _SP.ChangeCollection;
    var ChangeContentType = exports.ChangeContentType = _SP.ChangeContentType;
    var ChangeField = exports.ChangeField = _SP.ChangeField;
    var ChangeFile = exports.ChangeFile = _SP.ChangeFile;
    var ChangeFolder = exports.ChangeFolder = _SP.ChangeFolder;
    var ChangeGroup = exports.ChangeGroup = _SP.ChangeGroup;
    var ChangeItem = exports.ChangeItem = _SP.ChangeItem;
    var ChangeList = exports.ChangeList = _SP.ChangeList;
    var ChangeLogItemQuery = exports.ChangeLogItemQuery = _SP.ChangeLogItemQuery;
    var ChangeQuery = exports.ChangeQuery = _SP.ChangeQuery;
    var ChangeSite = exports.ChangeSite = _SP.ChangeSite;
    var ChangeToken = exports.ChangeToken = _SP.ChangeToken;
    var ChangeUser = exports.ChangeUser = _SP.ChangeUser;
    var ChangeView = exports.ChangeView = _SP.ChangeView;
    var ChangeWeb = exports.ChangeWeb = _SP.ChangeWeb;
    var CompatibilityRange = exports.CompatibilityRange = _SP.CompatibilityRange;
    var ContentType = exports.ContentType = _SP.ContentType;
    var ContentTypeCollection = exports.ContentTypeCollection = _SP.ContentTypeCollection;
    var ContentTypeCreationInformation = exports.ContentTypeCreationInformation = _SP.ContentTypeCreationInformation;
    var ContentTypeId = exports.ContentTypeId = _SP.ContentTypeId;
    var EventReceiverDefinition = exports.EventReceiverDefinition = _SP.EventReceiverDefinition;
    var EventReceiverDefinitionCollection = exports.EventReceiverDefinitionCollection = _SP.EventReceiverDefinitionCollection;
    var EventReceiverDefinitionCreationInformation = exports.EventReceiverDefinitionCreationInformation = _SP.EventReceiverDefinitionCreationInformation;
    var Feature = exports.Feature = _SP.Feature;
    var FeatureCollection = exports.FeatureCollection = _SP.FeatureCollection;
    var Field = exports.Field = _SP.Field;
    var FieldCalculated = exports.FieldCalculated = _SP.FieldCalculated;
    var FieldCalculatedErrorValue = exports.FieldCalculatedErrorValue = _SP.FieldCalculatedErrorValue;
    var FieldMultiChoice = exports.FieldMultiChoice = _SP.FieldMultiChoice;
    var FieldChoice = exports.FieldChoice = _SP.FieldChoice;
    var FieldCollection = exports.FieldCollection = _SP.FieldCollection;
    var FieldComputed = exports.FieldComputed = _SP.FieldComputed;
    var FieldNumber = exports.FieldNumber = _SP.FieldNumber;
    var FieldCurrency = exports.FieldCurrency = _SP.FieldCurrency;
    var FieldDateTime = exports.FieldDateTime = _SP.FieldDateTime;
    var FieldGeolocation = exports.FieldGeolocation = _SP.FieldGeolocation;
    var FieldGeolocationValue = exports.FieldGeolocationValue = _SP.FieldGeolocationValue;
    var FieldGuid = exports.FieldGuid = _SP.FieldGuid;
    var FieldLink = exports.FieldLink = _SP.FieldLink;
    var FieldLinkCollection = exports.FieldLinkCollection = _SP.FieldLinkCollection;
    var FieldLinkCreationInformation = exports.FieldLinkCreationInformation = _SP.FieldLinkCreationInformation;
    var FieldLookup = exports.FieldLookup = _SP.FieldLookup;
    var FieldLookupValue = exports.FieldLookupValue = _SP.FieldLookupValue;
    var FieldMultiLineText = exports.FieldMultiLineText = _SP.FieldMultiLineText;
    var FieldRatingScale = exports.FieldRatingScale = _SP.FieldRatingScale;
    var FieldRatingScaleQuestionAnswer = exports.FieldRatingScaleQuestionAnswer = _SP.FieldRatingScaleQuestionAnswer;
    var FieldStringValues = exports.FieldStringValues = _SP.FieldStringValues;
    var FieldText = exports.FieldText = _SP.FieldText;
    var FieldUrl = exports.FieldUrl = _SP.FieldUrl;
    var FieldUrlValue = exports.FieldUrlValue = _SP.FieldUrlValue;
    var FieldUser = exports.FieldUser = _SP.FieldUser;
    var FieldUserValue = exports.FieldUserValue = _SP.FieldUserValue;
    var File = exports.File = _SP.File;
    var FileCollection = exports.FileCollection = _SP.FileCollection;
    var FileCreationInformation = exports.FileCreationInformation = _SP.FileCreationInformation;
    var FileSaveBinaryInformation = exports.FileSaveBinaryInformation = _SP.FileSaveBinaryInformation;
    var FileVersion = exports.FileVersion = _SP.FileVersion;
    var FileVersionCollection = exports.FileVersionCollection = _SP.FileVersionCollection;
    var Folder = exports.Folder = _SP.Folder;
    var FolderCollection = exports.FolderCollection = _SP.FolderCollection;
    var Form = exports.Form = _SP.Form;
    var FormCollection = exports.FormCollection = _SP.FormCollection;
    var Principal = exports.Principal = _SP.Principal;
    var Group = exports.Group = _SP.Group;
    var GroupCollection = exports.GroupCollection = _SP.GroupCollection;
    var GroupCreationInformation = exports.GroupCreationInformation = _SP.GroupCreationInformation;
    var InformationRightsManagementSettings = exports.InformationRightsManagementSettings = _SP.InformationRightsManagementSettings;
    var Language = exports.Language = _SP.Language;
    var SecurableObject = exports.SecurableObject = _SP.SecurableObject;
    var List = exports.List = _SP.List;
    var ListCollection = exports.ListCollection = _SP.ListCollection;
    var ListCreationInformation = exports.ListCreationInformation = _SP.ListCreationInformation;
    var ListDataSource = exports.ListDataSource = _SP.ListDataSource;
    var ListDataValidationExceptionValue = exports.ListDataValidationExceptionValue = _SP.ListDataValidationExceptionValue;
    var ListDataValidationFailure = exports.ListDataValidationFailure = _SP.ListDataValidationFailure;
    var ListItem = exports.ListItem = _SP.ListItem;
    var ListItemCollection = exports.ListItemCollection = _SP.ListItemCollection;
    var ListItemCollectionPosition = exports.ListItemCollectionPosition = _SP.ListItemCollectionPosition;
    var ListItemCreationInformation = exports.ListItemCreationInformation = _SP.ListItemCreationInformation;
    var ListItemEntityCollection = exports.ListItemEntityCollection = _SP.ListItemEntityCollection;
    var ListItemFormUpdateValue = exports.ListItemFormUpdateValue = _SP.ListItemFormUpdateValue;
    var ListTemplate = exports.ListTemplate = _SP.ListTemplate;
    var ListTemplateCollection = exports.ListTemplateCollection = _SP.ListTemplateCollection;
    var Navigation = exports.Navigation = _SP.Navigation;
    var NavigationNode = exports.NavigationNode = _SP.NavigationNode;
    var NavigationNodeCollection = exports.NavigationNodeCollection = _SP.NavigationNodeCollection;
    var NavigationNodeCreationInformation = exports.NavigationNodeCreationInformation = _SP.NavigationNodeCreationInformation;
    var ObjectSharingInformation = exports.ObjectSharingInformation = _SP.ObjectSharingInformation;
    var ObjectSharingInformationUser = exports.ObjectSharingInformationUser = _SP.ObjectSharingInformationUser;
    var PropertyValues = exports.PropertyValues = _SP.PropertyValues;
    var PushNotificationSubscriber = exports.PushNotificationSubscriber = _SP.PushNotificationSubscriber;
    var PushNotificationSubscriberCollection = exports.PushNotificationSubscriberCollection = _SP.PushNotificationSubscriberCollection;
    var RecycleBinItem = exports.RecycleBinItem = _SP.RecycleBinItem;
    var RecycleBinItemCollection = exports.RecycleBinItemCollection = _SP.RecycleBinItemCollection;
    var RegionalSettings = exports.RegionalSettings = _SP.RegionalSettings;
    var RelatedField = exports.RelatedField = _SP.RelatedField;
    var RelatedFieldCollection = exports.RelatedFieldCollection = _SP.RelatedFieldCollection;
    var RelatedFieldExtendedData = exports.RelatedFieldExtendedData = _SP.RelatedFieldExtendedData;
    var RelatedFieldExtendedDataCollection = exports.RelatedFieldExtendedDataCollection = _SP.RelatedFieldExtendedDataCollection;
    var RelatedItem = exports.RelatedItem = _SP.RelatedItem;
    var RelatedItemManager = exports.RelatedItemManager = _SP.RelatedItemManager;
    var RequestVariable = exports.RequestVariable = _SP.RequestVariable;
    var RoleAssignment = exports.RoleAssignment = _SP.RoleAssignment;
    var RoleAssignmentCollection = exports.RoleAssignmentCollection = _SP.RoleAssignmentCollection;
    var RoleDefinition = exports.RoleDefinition = _SP.RoleDefinition;
    var RoleDefinitionBindingCollection = exports.RoleDefinitionBindingCollection = _SP.RoleDefinitionBindingCollection;
    var RoleDefinitionCollection = exports.RoleDefinitionCollection = _SP.RoleDefinitionCollection;
    var RoleDefinitionCreationInformation = exports.RoleDefinitionCreationInformation = _SP.RoleDefinitionCreationInformation;
    var ServerSettings = exports.ServerSettings = _SP.ServerSettings;
    var Site = exports.Site = _SP.Site;
    var SiteUrl = exports.SiteUrl = _SP.SiteUrl;
    var SubwebQuery = exports.SubwebQuery = _SP.SubwebQuery;
    var ThemeInfo = exports.ThemeInfo = _SP.ThemeInfo;
    var TimeZone = exports.TimeZone = _SP.TimeZone;
    var TimeZoneCollection = exports.TimeZoneCollection = _SP.TimeZoneCollection;
    var TimeZoneInformation = exports.TimeZoneInformation = _SP.TimeZoneInformation;
    var UpgradeInfo = exports.UpgradeInfo = _SP.UpgradeInfo;
    var UsageInfo = exports.UsageInfo = _SP.UsageInfo;
    var User = exports.User = _SP.User;
    var UserCollection = exports.UserCollection = _SP.UserCollection;
    var UserCreationInformation = exports.UserCreationInformation = _SP.UserCreationInformation;
    var UserCustomAction = exports.UserCustomAction = _SP.UserCustomAction;
    var UserCustomActionCollection = exports.UserCustomActionCollection = _SP.UserCustomActionCollection;
    var UserIdInfo = exports.UserIdInfo = _SP.UserIdInfo;
    var View = exports.View = _SP.View;
    var ViewCollection = exports.ViewCollection = _SP.ViewCollection;
    var ViewCreationInformation = exports.ViewCreationInformation = _SP.ViewCreationInformation;
    var ViewFieldCollection = exports.ViewFieldCollection = _SP.ViewFieldCollection;
    var Web = exports.Web = _SP.Web;
    var WebCollection = exports.WebCollection = _SP.WebCollection;
    var WebCreationInformation = exports.WebCreationInformation = _SP.WebCreationInformation;
    var WebInformation = exports.WebInformation = _SP.WebInformation;
    var WebProxy = exports.WebProxy = _SP.WebProxy;
    var WebRequestInfo = exports.WebRequestInfo = _SP.WebRequestInfo;
    var WebResponseInfo = exports.WebResponseInfo = _SP.WebResponseInfo;
    var WebTemplate = exports.WebTemplate = _SP.WebTemplate;
    var WebTemplateCollection = exports.WebTemplateCollection = _SP.WebTemplateCollection;

    var Application = exports.Application = function (__exports) {
        var UI = __exports.UI = function (__exports) {
            var FormsInfo = __exports.FormsInfo = _SP.Application.UI.FormsInfo;
            var DefaultFormsInformation = __exports.DefaultFormsInformation = _SP.Application.UI.DefaultFormsInformation;
            var DefaultFormsMenuBuilder = __exports.DefaultFormsMenuBuilder = _SP.Application.UI.DefaultFormsMenuBuilder;
            var ViewSelectorMenuOptions = __exports.ViewSelectorMenuOptions = _SP.Application.UI.ViewSelectorMenuOptions;
            var ViewSelectorGroups = __exports.ViewSelectorGroups = _SP.Application.UI.ViewSelectorGroups;
            var ViewSelectorMenuItem = __exports.ViewSelectorMenuItem = _SP.Application.UI.ViewSelectorMenuItem;
            var ViewSelectorSubMenu = __exports.ViewSelectorSubMenu = _SP.Application.UI.ViewSelectorSubMenu;
            var ViewSelectorMenuBuilder = __exports.ViewSelectorMenuBuilder = _SP.Application.UI.ViewSelectorMenuBuilder;
            var MoreColorsPicker = __exports.MoreColorsPicker = _SP.Application.UI.MoreColorsPicker;
            var MoreColorsPage = __exports.MoreColorsPage = _SP.Application.UI.MoreColorsPage;
            var ThemeWebPage = __exports.ThemeWebPage = _SP.Application.UI.ThemeWebPage;
            var WikiPageNameInPlaceEditor = __exports.WikiPageNameInPlaceEditor = _SP.Application.UI.WikiPageNameInPlaceEditor;
            return __exports;
        }({});

        return __exports;
    }({});

    var Analytics = exports.Analytics = function (__exports) {
        var AnalyticsUsageEntry = __exports.AnalyticsUsageEntry = _SP.Analytics.AnalyticsUsageEntry;
        return __exports;
    }({});

    var SiteHealth = exports.SiteHealth = function (__exports) {
        var SiteHealthResult = __exports.SiteHealthResult = _SP.SiteHealth.SiteHealthResult;
        var SiteHealthSummary = __exports.SiteHealthSummary = _SP.SiteHealth.SiteHealthSummary;
        return __exports;
    }({});

    var BusinessData = exports.BusinessData = function (__exports) {
        var AppBdcCatalog = __exports.AppBdcCatalog = _SP.BusinessData.AppBdcCatalog;
        var Entity = __exports.Entity = _SP.BusinessData.Entity;
        var EntityField = __exports.EntityField = _SP.BusinessData.EntityField;
        var EntityIdentifier = __exports.EntityIdentifier = _SP.BusinessData.EntityIdentifier;
        var EntityView = __exports.EntityView = _SP.BusinessData.EntityView;
        var Filter = __exports.Filter = _SP.BusinessData.Filter;
        var LobSystem = __exports.LobSystem = _SP.BusinessData.LobSystem;
        var LobSystemInstance = __exports.LobSystemInstance = _SP.BusinessData.LobSystemInstance;
        var MethodExecutionResult = __exports.MethodExecutionResult = _SP.BusinessData.MethodExecutionResult;
        var ReturnParameterCollection = __exports.ReturnParameterCollection = _SP.BusinessData.ReturnParameterCollection;
        var TypeDescriptor = __exports.TypeDescriptor = _SP.BusinessData.TypeDescriptor;

        var Collections = __exports.Collections = function (__exports) {
            var EntityFieldCollection = __exports.EntityFieldCollection = _SP.BusinessData.Collections.EntityFieldCollection;
            var EntityIdentifierCollection = __exports.EntityIdentifierCollection = _SP.BusinessData.Collections.EntityIdentifierCollection;
            var EntityInstanceCollection = __exports.EntityInstanceCollection = _SP.BusinessData.Collections.EntityInstanceCollection;
            var FilterCollection = __exports.FilterCollection = _SP.BusinessData.Collections.FilterCollection;
            var LobSystemInstanceCollection = __exports.LobSystemInstanceCollection = _SP.BusinessData.Collections.LobSystemInstanceCollection;
            var TypeDescriptorCollection = __exports.TypeDescriptorCollection = _SP.BusinessData.Collections.TypeDescriptorCollection;
            return __exports;
        }({});

        var Infrastructure = __exports.Infrastructure = function (__exports) {
            var ExternalSubscriptionStore = __exports.ExternalSubscriptionStore = _SP.BusinessData.Infrastructure.ExternalSubscriptionStore;
            return __exports;
        }({});

        var Runtime = __exports.Runtime = function (__exports) {
            var EntityFieldValueDictionary = __exports.EntityFieldValueDictionary = _SP.BusinessData.Runtime.EntityFieldValueDictionary;
            var EntityIdentity = __exports.EntityIdentity = _SP.BusinessData.Runtime.EntityIdentity;
            var EntityInstance = __exports.EntityInstance = _SP.BusinessData.Runtime.EntityInstance;
            var NotificationCallback = __exports.NotificationCallback = _SP.BusinessData.Runtime.NotificationCallback;
            var Subscription = __exports.Subscription = _SP.BusinessData.Runtime.Subscription;
            return __exports;
        }({});

        return __exports;
    }({});

    var Sharing = exports.Sharing = function (__exports) {
        var DocumentSharingManager = __exports.DocumentSharingManager = _SP.Sharing.DocumentSharingManager;
        var UserRoleAssignment = __exports.UserRoleAssignment = _SP.Sharing.UserRoleAssignment;
        var UserSharingResult = __exports.UserSharingResult = _SP.Sharing.UserSharingResult;
        return __exports;
    }({});

    var Social = exports.Social = function (__exports) {
        var SocialActor = __exports.SocialActor = _SP.Social.SocialActor;
        var SocialActorInfo = __exports.SocialActorInfo = _SP.Social.SocialActorInfo;
        var SocialAttachment = __exports.SocialAttachment = _SP.Social.SocialAttachment;
        var SocialAttachmentAction = __exports.SocialAttachmentAction = _SP.Social.SocialAttachmentAction;
        var SocialDataItem = __exports.SocialDataItem = _SP.Social.SocialDataItem;
        var SocialDataOverlay = __exports.SocialDataOverlay = _SP.Social.SocialDataOverlay;
        var SocialExceptionDetails = __exports.SocialExceptionDetails = _SP.Social.SocialExceptionDetails;
        var SocialFeed = __exports.SocialFeed = _SP.Social.SocialFeed;
        var SocialFeedManager = __exports.SocialFeedManager = _SP.Social.SocialFeedManager;
        var SocialFeedOptions = __exports.SocialFeedOptions = _SP.Social.SocialFeedOptions;
        var SocialFollowingManager = __exports.SocialFollowingManager = _SP.Social.SocialFollowingManager;
        var SocialLink = __exports.SocialLink = _SP.Social.SocialLink;
        var SocialPost = __exports.SocialPost = _SP.Social.SocialPost;
        var SocialPostActorInfo = __exports.SocialPostActorInfo = _SP.Social.SocialPostActorInfo;
        var SocialPostCreationData = __exports.SocialPostCreationData = _SP.Social.SocialPostCreationData;
        var SocialPostDefinitionData = __exports.SocialPostDefinitionData = _SP.Social.SocialPostDefinitionData;
        var SocialPostDefinitionDataItem = __exports.SocialPostDefinitionDataItem = _SP.Social.SocialPostDefinitionDataItem;
        var SocialPostReference = __exports.SocialPostReference = _SP.Social.SocialPostReference;
        var SocialThread = __exports.SocialThread = _SP.Social.SocialThread;
        return __exports;
    }({});

    var Taxonomy = exports.Taxonomy = function (__exports) {
        var TaxonomySession = __exports.TaxonomySession = _SP.Taxonomy.TaxonomySession;
        var TermStoreCollection = __exports.TermStoreCollection = _SP.Taxonomy.TermStoreCollection;
        var TermStore = __exports.TermStore = _SP.Taxonomy.TermStore;
        var TaxonomyItem = __exports.TaxonomyItem = _SP.Taxonomy.TaxonomyItem;
        var TermGroupCollection = __exports.TermGroupCollection = _SP.Taxonomy.TermGroupCollection;
        var TermGroup = __exports.TermGroup = _SP.Taxonomy.TermGroup;
        var TermSetItem = __exports.TermSetItem = _SP.Taxonomy.TermSetItem;
        var TermSetCollection = __exports.TermSetCollection = _SP.Taxonomy.TermSetCollection;
        var TermSet = __exports.TermSet = _SP.Taxonomy.TermSet;
        var TermCollection = __exports.TermCollection = _SP.Taxonomy.TermCollection;
        var Term = __exports.Term = _SP.Taxonomy.Term;
        var LabelCollection = __exports.LabelCollection = _SP.Taxonomy.LabelCollection;
        var Label = __exports.Label = _SP.Taxonomy.Label;
        var LabelMatchInformation = __exports.LabelMatchInformation = _SP.Taxonomy.LabelMatchInformation;
        var CustomPropertyMatchInformation = __exports.CustomPropertyMatchInformation = _SP.Taxonomy.CustomPropertyMatchInformation;
        var ChangeInformation = __exports.ChangeInformation = _SP.Taxonomy.ChangeInformation;
        var ChangedItemCollection = __exports.ChangedItemCollection = _SP.Taxonomy.ChangedItemCollection;
        var ChangedItem = __exports.ChangedItem = _SP.Taxonomy.ChangedItem;
        var ChangedSite = __exports.ChangedSite = _SP.Taxonomy.ChangedSite;
        var ChangedGroup = __exports.ChangedGroup = _SP.Taxonomy.ChangedGroup;
        var ChangedTerm = __exports.ChangedTerm = _SP.Taxonomy.ChangedTerm;
        var ChangedTermSet = __exports.ChangedTermSet = _SP.Taxonomy.ChangedTermSet;
        var ChangedTermStore = __exports.ChangedTermStore = _SP.Taxonomy.ChangedTermStore;
        var TaxonomyField = __exports.TaxonomyField = _SP.Taxonomy.TaxonomyField;
        var TaxonomyFieldValueCollection = __exports.TaxonomyFieldValueCollection = _SP.Taxonomy.TaxonomyFieldValueCollection;
        var TaxonomyFieldValue = __exports.TaxonomyFieldValue = _SP.Taxonomy.TaxonomyFieldValue;
        var MobileTaxonomyField = __exports.MobileTaxonomyField = _SP.Taxonomy.MobileTaxonomyField;
        return __exports;
    }({});

    var DocumentSet = exports.DocumentSet = function (__exports) {
        var DocumentSet = __exports.DocumentSet = _SP.DocumentSet.DocumentSet;
        return __exports;
    }({});

    var Video = exports.Video = function (__exports) {
        var EmbedCodeConfiguration = __exports.EmbedCodeConfiguration = _SP.Video.EmbedCodeConfiguration;
        var VideoSet = __exports.VideoSet = _SP.Video.VideoSet;
        return __exports;
    }({});

    var UI = exports.UI = function (__exports) {
        var ApplicationPages = __exports.ApplicationPages = function (__exports) {
            var SelectorSelectionEventArgs = __exports.SelectorSelectionEventArgs = _SP.UI.ApplicationPages.SelectorSelectionEventArgs;
            var CalendarSelector = __exports.CalendarSelector = _SP.UI.ApplicationPages.CalendarSelector;
            var BaseSelectorComponent = __exports.BaseSelectorComponent = _SP.UI.ApplicationPages.BaseSelectorComponent;
            var CalendarInstanceRepository = __exports.CalendarInstanceRepository = _SP.UI.ApplicationPages.CalendarInstanceRepository;
            var ResolveEntity = __exports.ResolveEntity = _SP.UI.ApplicationPages.ResolveEntity;
            var ClientPeoplePickerQueryParameters = __exports.ClientPeoplePickerQueryParameters = _SP.UI.ApplicationPages.ClientPeoplePickerQueryParameters;
            var ClientPeoplePickerWebServiceInterface = __exports.ClientPeoplePickerWebServiceInterface = _SP.UI.ApplicationPages.ClientPeoplePickerWebServiceInterface;
            var PeoplePickerWebServiceInterface = __exports.PeoplePickerWebServiceInterface = _SP.UI.ApplicationPages.PeoplePickerWebServiceInterface;
            return __exports;
        }({});

        var PopoutMenu = __exports.PopoutMenu = _SP.UI.PopoutMenu;
        var AttractModeControl = __exports.AttractModeControl = _SP.UI.AttractModeControl;
        var Status = __exports.Status = _SP.UI.Status;
        var Menu = __exports.Menu = _SP.UI.Menu;
        var MenuTest = __exports.MenuTest = _SP.UI.MenuTest;
        var DialogOptions = __exports.DialogOptions = _SP.UI.DialogOptions;
        var Dialog = __exports.Dialog = _SP.UI.Dialog;
        var ModalDialog = __exports.ModalDialog = _SP.UI.ModalDialog;
        var Command = __exports.Command = _SP.UI.Command;
        var CommandBar = __exports.CommandBar = _SP.UI.CommandBar;
        var PagingControl = __exports.PagingControl = _SP.UI.PagingControl;
        var Globals = __exports.Globals = _SP.UI;

        var Notify = __exports.Notify = function (__exports) {
            var Notification = __exports.Notification = _SP.UI.Notify.Notification;
            var NotificationContainer = __exports.NotificationContainer = _SP.UI.Notify.NotificationContainer;
            var Globals_1 = __exports.Globals = _SP.UI.Notify;
            return __exports;
        }({});

        var Workspace = __exports.Workspace = function (__exports) {
            var Globals_1 = __exports.Globals = _SP.UI.Workspace;
            return __exports;
        }({});

        var Workplace = __exports.Workplace = function (__exports) {
            var Globals_1 = __exports.Globals = _SP.UI.Workplace;
            return __exports;
        }({});

        var UIUtility = __exports.UIUtility = function (__exports) {
            var Globals_1 = __exports.Globals = _SP.UI.UIUtility;
            return __exports;
        }({});

        var Controls = __exports.Controls = function (__exports) {
            var NavigationOptions = __exports.NavigationOptions = _SP.UI.Controls.NavigationOptions;
            var SettingsLink = __exports.SettingsLink = _SP.UI.Controls.SettingsLink;
            var Navigation_1 = __exports.Navigation = _SP.UI.Controls.Navigation;
            var ControlManager = __exports.ControlManager = _SP.UI.Controls.ControlManager;
            return __exports;
        }({});

        return __exports;
    }({});

    var UserProfiles = exports.UserProfiles = function (__exports) {
        var HashTag = __exports.HashTag = _SP.UserProfiles.HashTag;
        var HashTagCollection = __exports.HashTagCollection = _SP.UserProfiles.HashTagCollection;
        var PeopleManager = __exports.PeopleManager = _SP.UserProfiles.PeopleManager;
        var PersonProperties = __exports.PersonProperties = _SP.UserProfiles.PersonProperties;
        var ProfileLoader = __exports.ProfileLoader = _SP.UserProfiles.ProfileLoader;
        var UserProfile = __exports.UserProfile = _SP.UserProfiles.UserProfile;
        var FollowedContent = __exports.FollowedContent = _SP.UserProfiles.FollowedContent;
        var FollowedItem = __exports.FollowedItem = _SP.UserProfiles.FollowedItem;
        var FollowedItemData = __exports.FollowedItemData = _SP.UserProfiles.FollowedItemData;
        var FollowResult = __exports.FollowResult = _SP.UserProfiles.FollowResult;
        var UserProfilePropertiesForUser = __exports.UserProfilePropertiesForUser = _SP.UserProfiles.UserProfilePropertiesForUser;
        return __exports;
    }({});

    var Utilities = exports.Utilities = function (__exports) {
        var Utility = __exports.Utility = _SP.Utilities.Utility;
        var EmailProperties = __exports.EmailProperties = _SP.Utilities.EmailProperties;
        var PrincipalInfo = __exports.PrincipalInfo = _SP.Utilities.PrincipalInfo;
        var WikiPageCreationInformation = __exports.WikiPageCreationInformation = _SP.Utilities.WikiPageCreationInformation;
        var DateUtility = __exports.DateUtility = _SP.Utilities.DateUtility;
        var HttpUtility = __exports.HttpUtility = _SP.Utilities.HttpUtility;
        var UrlBuilder = __exports.UrlBuilder = _SP.Utilities.UrlBuilder;
        var LocUtility = __exports.LocUtility = _SP.Utilities.LocUtility;
        var VersionUtility = __exports.VersionUtility = _SP.Utilities.VersionUtility;
        return __exports;
    }({});

    var DateTimeUtil = exports.DateTimeUtil = function (__exports) {
        var SimpleDate = __exports.SimpleDate = _SP.DateTimeUtil.SimpleDate;
        return __exports;
    }({});

    var WebParts = exports.WebParts = function (__exports) {
        var LimitedWebPartManager = __exports.LimitedWebPartManager = _SP.WebParts.LimitedWebPartManager;
        var TileData = __exports.TileData = _SP.WebParts.TileData;
        var WebPart = __exports.WebPart = _SP.WebParts.WebPart;
        var WebPartDefinition = __exports.WebPartDefinition = _SP.WebParts.WebPartDefinition;
        var WebPartDefinitionCollection = __exports.WebPartDefinitionCollection = _SP.WebParts.WebPartDefinitionCollection;
        return __exports;
    }({});

    var Workflow = exports.Workflow = function (__exports) {
        var WorkflowAssociation = __exports.WorkflowAssociation = _SP.Workflow.WorkflowAssociation;
        var WorkflowAssociationCollection = __exports.WorkflowAssociationCollection = _SP.Workflow.WorkflowAssociationCollection;
        var WorkflowAssociationCreationInformation = __exports.WorkflowAssociationCreationInformation = _SP.Workflow.WorkflowAssociationCreationInformation;
        var WorkflowTemplate = __exports.WorkflowTemplate = _SP.Workflow.WorkflowTemplate;
        var WorkflowTemplateCollection = __exports.WorkflowTemplateCollection = _SP.Workflow.WorkflowTemplateCollection;
        return __exports;
    }({});

    var Publishing = exports.Publishing = function (__exports) {
        var PublishingWeb = __exports.PublishingWeb = _SP.Publishing.PublishingWeb;
        var PublishingPageInformation = __exports.PublishingPageInformation = _SP.Publishing.PublishingPageInformation;
        var PublishingPage = __exports.PublishingPage = _SP.Publishing.PublishingPage;
        var ScheduledItem = __exports.ScheduledItem = _SP.Publishing.ScheduledItem;
        var PublishingSite = __exports.PublishingSite = _SP.Publishing.PublishingSite;
        var PageLayoutCreationInformation = __exports.PageLayoutCreationInformation = _SP.Publishing.PageLayoutCreationInformation;
        var SiteServicesAddins = __exports.SiteServicesAddins = _SP.Publishing.SiteServicesAddins;
        var AddinSettings = __exports.AddinSettings = _SP.Publishing.AddinSettings;
        var AddinPlugin = __exports.AddinPlugin = _SP.Publishing.AddinPlugin;
        var DesignPackage = __exports.DesignPackage = _SP.Publishing.DesignPackage;
        var DesignPackageInfo = __exports.DesignPackageInfo = _SP.Publishing.DesignPackageInfo;
        var SiteImageRenditions = __exports.SiteImageRenditions = _SP.Publishing.SiteImageRenditions;
        var ImageRendition = __exports.ImageRendition = _SP.Publishing.ImageRendition;
        var Variations = __exports.Variations = _SP.Publishing.Variations;
        var VariationLabel = __exports.VariationLabel = _SP.Publishing.VariationLabel;
        var CustomizableString = __exports.CustomizableString = _SP.Publishing.CustomizableString;

        var Navigation_1 = __exports.Navigation = function (__exports) {
            var NavigationTermSetItem = __exports.NavigationTermSetItem = _SP.Publishing.Navigation.NavigationTermSetItem;
            var NavigationTermCollection = __exports.NavigationTermCollection = _SP.Publishing.Navigation.NavigationTermCollection;
            var NavigationTerm = __exports.NavigationTerm = _SP.Publishing.Navigation.NavigationTerm;
            var NavigationTermSet = __exports.NavigationTermSet = _SP.Publishing.Navigation.NavigationTermSet;
            var NavigationTermProviderNameCollection = __exports.NavigationTermProviderNameCollection = _SP.Publishing.Navigation.NavigationTermProviderNameCollection;
            var NavigationTermSetView = __exports.NavigationTermSetView = _SP.Publishing.Navigation.NavigationTermSetView;
            var TaxonomyNavigation = __exports.TaxonomyNavigation = _SP.Publishing.Navigation.TaxonomyNavigation;
            var WebNavigationSettings = __exports.WebNavigationSettings = _SP.Publishing.Navigation.WebNavigationSettings;
            var StandardNavigationSettings = __exports.StandardNavigationSettings = _SP.Publishing.Navigation.StandardNavigationSettings;
            return __exports;
        }({});

        return __exports;
    }({});

    var CompliancePolicy = exports.CompliancePolicy = function (__exports) {
        var SPContainerId = __exports.SPContainerId = _SP.CompliancePolicy.SPContainerId;
        var SPPolicyAssociation = __exports.SPPolicyAssociation = _SP.CompliancePolicy.SPPolicyAssociation;
        var SPPolicyBinding = __exports.SPPolicyBinding = _SP.CompliancePolicy.SPPolicyBinding;
        var SPPolicyDefinition = __exports.SPPolicyDefinition = _SP.CompliancePolicy.SPPolicyDefinition;
        var SPPolicyRule = __exports.SPPolicyRule = _SP.CompliancePolicy.SPPolicyRule;
        var SPPolicyStore = __exports.SPPolicyStore = _SP.CompliancePolicy.SPPolicyStore;
        var SPPolicyStoreProxy = __exports.SPPolicyStoreProxy = _SP.CompliancePolicy.SPPolicyStoreProxy;
        return __exports;
    }({});

    var Discovery = exports.Discovery = function (__exports) {
        var Case = __exports.Case = _SP.Discovery.Case;
        var Export = __exports.Export = _SP.Discovery.Export;
        return __exports;
    }({});

    var InformationPolicy = exports.InformationPolicy = function (__exports) {
        var ProjectPolicy = __exports.ProjectPolicy = _SP.InformationPolicy.ProjectPolicy;
        return __exports;
    }({});
});
//# sourceMappingURL=Fable.Import.SharePoint.SP.js.map